const rl = @import("raylib.zig");

const Input = struct {
    name: []const u8,
    code: i32,
    default: i32,

    pub fn isDown(self: Input) bool {
        return rl.isKeyDown(self.code);
    }
    pub fn isJustPressed(self: Input) bool {
        return rl.isKeyPressed(self.code);
    }
    pub fn isJustReleased(self: Input) bool {
        return rl.isKeyReleased(self.code);
    }
};

fn init(comptime name: []const u8, comptime key_code: []const u8) Input {
    return Input{
        .name = name,
        .code = rl.getKeyCode(key_code),
        .default = rl.getKeyCode(key_code),
    };
}

pub const menu_left = init("Menu Left", "LEFT");
pub const menu_right = init("Menu Right", "RIGHT");
pub const menu_down = init("Menu Down", "DOWN");
pub const menu_up = init("Menu Up", "UP");
pub const menu_accept = init("Menu Accept", "ENTER");
pub const menu_cancel = init("Menu Cancel", "BACKSPACE");
